<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for documentType StructType
 * @subpackage Structs
 */
class DocumentType extends AbstractStructBase
{
    /**
     * The NOTICE
     * Meta informations extracted from the WSDL
     * - ref: NOTICE
     * @var \StructType\NOTICE
     */
    public $NOTICE;
    /**
     * The CONTENT_URL
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - ref: CONTENT_URL
     * @var \StructType\CONTENT_URL[]
     */
    public $CONTENT_URL;
    /**
     * Constructor method for documentType
     * @uses DocumentType::setNOTICE()
     * @uses DocumentType::setCONTENT_URL()
     * @param \StructType\NOTICE $nOTICE
     * @param \StructType\CONTENT_URL[] $cONTENT_URL
     */
    public function __construct(\StructType\NOTICE $nOTICE = null, array $cONTENT_URL = array())
    {
        $this
            ->setNOTICE($nOTICE)
            ->setCONTENT_URL($cONTENT_URL);
    }
    /**
     * Get NOTICE value
     * @return \StructType\NOTICE|null
     */
    public function getNOTICE()
    {
        return $this->NOTICE;
    }
    /**
     * Set NOTICE value
     * @param \StructType\NOTICE $nOTICE
     * @return \StructType\DocumentType
     */
    public function setNOTICE(\StructType\NOTICE $nOTICE = null)
    {
        $this->NOTICE = $nOTICE;
        return $this;
    }
    /**
     * Get CONTENT_URL value
     * @return \StructType\CONTENT_URL[]|null
     */
    public function getCONTENT_URL()
    {
        return $this->CONTENT_URL;
    }
    /**
     * Set CONTENT_URL value
     * @throws \InvalidArgumentException
     * @param \StructType\CONTENT_URL[] $cONTENT_URL
     * @return \StructType\DocumentType
     */
    public function setCONTENT_URL(array $cONTENT_URL = array())
    {
        foreach ($cONTENT_URL as $documentTypeCONTENT_URLItem) {
            // validation for constraint: itemType
            if (!$documentTypeCONTENT_URLItem instanceof \StructType\CONTENT_URL) {
                throw new \InvalidArgumentException(sprintf('The CONTENT_URL property can only contain items of \StructType\CONTENT_URL, "%s" given', is_object($documentTypeCONTENT_URLItem) ? get_class($documentTypeCONTENT_URLItem) : gettype($documentTypeCONTENT_URLItem)), __LINE__);
            }
        }
        $this->CONTENT_URL = $cONTENT_URL;
        return $this;
    }
    /**
     * Add item to CONTENT_URL value
     * @throws \InvalidArgumentException
     * @param \StructType\CONTENT_URL $item
     * @return \StructType\DocumentType
     */
    public function addToCONTENT_URL(\StructType\CONTENT_URL $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CONTENT_URL) {
            throw new \InvalidArgumentException(sprintf('The CONTENT_URL property can only contain items of \StructType\CONTENT_URL, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CONTENT_URL[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DocumentType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
