<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for embeddedExpressionType StructType
 * @subpackage Structs
 */
class EmbeddedExpressionType extends AbstractStructBase
{
    /**
     * The EXPRESSION_TITLE
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - ref: EXPRESSION_TITLE
     * @var \StructType\Literal[]
     */
    public $EXPRESSION_TITLE;
    /**
     * The EXPRESSION_USES_LANGUAGE
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - ref: EXPRESSION_USES_LANGUAGE
     * @var \StructType\Concept[]
     */
    public $EXPRESSION_USES_LANGUAGE;
    /**
     * The SAMEAS
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - ref: SAMEAS
     * @var \StructType\SAMEAS[]
     */
    public $SAMEAS;
    /**
     * The URI
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\URI
     */
    public $URI;
    /**
     * Constructor method for embeddedExpressionType
     * @uses EmbeddedExpressionType::setEXPRESSION_TITLE()
     * @uses EmbeddedExpressionType::setEXPRESSION_USES_LANGUAGE()
     * @uses EmbeddedExpressionType::setSAMEAS()
     * @uses EmbeddedExpressionType::setURI()
     * @param \StructType\Literal[] $eXPRESSION_TITLE
     * @param \StructType\Concept[] $eXPRESSION_USES_LANGUAGE
     * @param \StructType\SAMEAS[] $sAMEAS
     * @param \StructType\URI $uRI
     */
    public function __construct(array $eXPRESSION_TITLE = array(), array $eXPRESSION_USES_LANGUAGE = array(), array $sAMEAS = array(), \StructType\URI $uRI = null)
    {
        $this
            ->setEXPRESSION_TITLE($eXPRESSION_TITLE)
            ->setEXPRESSION_USES_LANGUAGE($eXPRESSION_USES_LANGUAGE)
            ->setSAMEAS($sAMEAS)
            ->setURI($uRI);
    }
    /**
     * Get EXPRESSION_TITLE value
     * @return \StructType\Literal[]|null
     */
    public function getEXPRESSION_TITLE()
    {
        return $this->EXPRESSION_TITLE;
    }
    /**
     * Set EXPRESSION_TITLE value
     * @throws \InvalidArgumentException
     * @param \StructType\Literal[] $eXPRESSION_TITLE
     * @return \StructType\EmbeddedExpressionType
     */
    public function setEXPRESSION_TITLE(array $eXPRESSION_TITLE = array())
    {
        foreach ($eXPRESSION_TITLE as $embeddedExpressionTypeEXPRESSION_TITLEItem) {
            // validation for constraint: itemType
            if (!$embeddedExpressionTypeEXPRESSION_TITLEItem instanceof \StructType\Literal) {
                throw new \InvalidArgumentException(sprintf('The EXPRESSION_TITLE property can only contain items of \StructType\Literal, "%s" given', is_object($embeddedExpressionTypeEXPRESSION_TITLEItem) ? get_class($embeddedExpressionTypeEXPRESSION_TITLEItem) : gettype($embeddedExpressionTypeEXPRESSION_TITLEItem)), __LINE__);
            }
        }
        $this->EXPRESSION_TITLE = $eXPRESSION_TITLE;
        return $this;
    }
    /**
     * Add item to EXPRESSION_TITLE value
     * @throws \InvalidArgumentException
     * @param \StructType\Literal $item
     * @return \StructType\EmbeddedExpressionType
     */
    public function addToEXPRESSION_TITLE(\StructType\Literal $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Literal) {
            throw new \InvalidArgumentException(sprintf('The EXPRESSION_TITLE property can only contain items of \StructType\Literal, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->EXPRESSION_TITLE[] = $item;
        return $this;
    }
    /**
     * Get EXPRESSION_USES_LANGUAGE value
     * @return \StructType\Concept[]|null
     */
    public function getEXPRESSION_USES_LANGUAGE()
    {
        return $this->EXPRESSION_USES_LANGUAGE;
    }
    /**
     * Set EXPRESSION_USES_LANGUAGE value
     * @throws \InvalidArgumentException
     * @param \StructType\Concept[] $eXPRESSION_USES_LANGUAGE
     * @return \StructType\EmbeddedExpressionType
     */
    public function setEXPRESSION_USES_LANGUAGE(array $eXPRESSION_USES_LANGUAGE = array())
    {
        foreach ($eXPRESSION_USES_LANGUAGE as $embeddedExpressionTypeEXPRESSION_USES_LANGUAGEItem) {
            // validation for constraint: itemType
            if (!$embeddedExpressionTypeEXPRESSION_USES_LANGUAGEItem instanceof \StructType\Concept) {
                throw new \InvalidArgumentException(sprintf('The EXPRESSION_USES_LANGUAGE property can only contain items of \StructType\Concept, "%s" given', is_object($embeddedExpressionTypeEXPRESSION_USES_LANGUAGEItem) ? get_class($embeddedExpressionTypeEXPRESSION_USES_LANGUAGEItem) : gettype($embeddedExpressionTypeEXPRESSION_USES_LANGUAGEItem)), __LINE__);
            }
        }
        $this->EXPRESSION_USES_LANGUAGE = $eXPRESSION_USES_LANGUAGE;
        return $this;
    }
    /**
     * Add item to EXPRESSION_USES_LANGUAGE value
     * @throws \InvalidArgumentException
     * @param \StructType\Concept $item
     * @return \StructType\EmbeddedExpressionType
     */
    public function addToEXPRESSION_USES_LANGUAGE(\StructType\Concept $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Concept) {
            throw new \InvalidArgumentException(sprintf('The EXPRESSION_USES_LANGUAGE property can only contain items of \StructType\Concept, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->EXPRESSION_USES_LANGUAGE[] = $item;
        return $this;
    }
    /**
     * Get SAMEAS value
     * @return \StructType\SAMEAS[]|null
     */
    public function getSAMEAS()
    {
        return $this->SAMEAS;
    }
    /**
     * Set SAMEAS value
     * @throws \InvalidArgumentException
     * @param \StructType\SAMEAS[] $sAMEAS
     * @return \StructType\EmbeddedExpressionType
     */
    public function setSAMEAS(array $sAMEAS = array())
    {
        foreach ($sAMEAS as $embeddedExpressionTypeSAMEASItem) {
            // validation for constraint: itemType
            if (!$embeddedExpressionTypeSAMEASItem instanceof \StructType\SAMEAS) {
                throw new \InvalidArgumentException(sprintf('The SAMEAS property can only contain items of \StructType\SAMEAS, "%s" given', is_object($embeddedExpressionTypeSAMEASItem) ? get_class($embeddedExpressionTypeSAMEASItem) : gettype($embeddedExpressionTypeSAMEASItem)), __LINE__);
            }
        }
        $this->SAMEAS = $sAMEAS;
        return $this;
    }
    /**
     * Add item to SAMEAS value
     * @throws \InvalidArgumentException
     * @param \StructType\SAMEAS $item
     * @return \StructType\EmbeddedExpressionType
     */
    public function addToSAMEAS(\StructType\SAMEAS $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SAMEAS) {
            throw new \InvalidArgumentException(sprintf('The SAMEAS property can only contain items of \StructType\SAMEAS, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->SAMEAS[] = $item;
        return $this;
    }
    /**
     * Get URI value
     * @return \StructType\URI|null
     */
    public function getURI()
    {
        return $this->URI;
    }
    /**
     * Set URI value
     * @param \StructType\URI $uRI
     * @return \StructType\EmbeddedExpressionType
     */
    public function setURI(\StructType\URI $uRI = null)
    {
        $this->URI = $uRI;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\EmbeddedExpressionType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
