<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for embeddedManifestationType StructType
 * @subpackage Structs
 */
class EmbeddedManifestationType extends AbstractStructBase
{
    /**
     * The MANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_FIRST
     */
    public $MANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_FIRST;
    /**
     * The MANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_LAST
     */
    public $MANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_LAST;
    /**
     * The MANIFESTATION_PART_OF_MANIFESTATION
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - ref: MANIFESTATION_PART_OF_MANIFESTATION
     * @var \StructType\Concept[]
     */
    public $MANIFESTATION_PART_OF_MANIFESTATION;
    /**
     * The MANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_FIRST
     */
    public $MANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_FIRST;
    /**
     * The MANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_LAST
     */
    public $MANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_LAST;
    /**
     * The SAMEAS
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - ref: SAMEAS
     * @var \StructType\SAMEAS[]
     */
    public $SAMEAS;
    /**
     * The URI
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\URI
     */
    public $URI;
    /**
     * The manifestation_type
     */
    public $manifestation_type;
    /**
     * Constructor method for embeddedManifestationType
     * @uses EmbeddedManifestationType::setMANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_FIRST()
     * @uses EmbeddedManifestationType::setMANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_LAST()
     * @uses EmbeddedManifestationType::setMANIFESTATION_PART_OF_MANIFESTATION()
     * @uses EmbeddedManifestationType::setMANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_FIRST()
     * @uses EmbeddedManifestationType::setMANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_LAST()
     * @uses EmbeddedManifestationType::setSAMEAS()
     * @uses EmbeddedManifestationType::setURI()
     * @uses EmbeddedManifestationType::setManifestation_type()
     * @param \StructType\Literal[] $mANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_FIRST
     * @param \StructType\Literal[] $mANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_LAST
     * @param \StructType\Concept[] $mANIFESTATION_PART_OF_MANIFESTATION
     * @param \StructType\Literal[] $mANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_FIRST
     * @param \StructType\Literal[] $mANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_LAST
     * @param \StructType\SAMEAS[] $sAMEAS
     * @param \StructType\URI $uRI
     * @param UNKNOWN $manifestation_type
     */
    public function __construct(array $mANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_FIRST = array(), array $mANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_LAST = array(), array $mANIFESTATION_PART_OF_MANIFESTATION = array(), array $mANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_FIRST = array(), array $mANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_LAST = array(), array $sAMEAS = array(), \StructType\URI $uRI = null, UNKNOWN $manifestation_type = null)
    {
        $this
            ->setMANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_FIRST($mANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_FIRST)
            ->setMANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_LAST($mANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_LAST)
            ->setMANIFESTATION_PART_OF_MANIFESTATION($mANIFESTATION_PART_OF_MANIFESTATION)
            ->setMANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_FIRST($mANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_FIRST)
            ->setMANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_LAST($mANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_LAST)
            ->setSAMEAS($sAMEAS)
            ->setURI($uRI)
            ->setManifestation_type($manifestation_type);
    }
    /**
     * Get mANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_FIRST value
     * @return mANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_FIRST
     */
    public function getMANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_FIRST()
    {
        return $this->{'MANIFESTATION_OFFICIAL-JOURNAL_PART_PAGE_FIRST'};
    }
    /**
     * Set mANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_FIRST value
     * @param mANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_FIRST $mANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_FIRST
     * @return \StructType\EmbeddedManifestationType
     */
    public function setMANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_FIRST(array $mANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_FIRST = array())
    {
        foreach ($mANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_FIRST as $embeddedManifestationTypeMANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_FIRSTItem) {
            // validation for constraint: itemType
            if (!$embeddedManifestationTypeMANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_FIRSTItem instanceof \StructType\Literal) {
                throw new \InvalidArgumentException(sprintf('The MANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_FIRST property can only contain items of \StructType\Literal, "%s" given', is_object($embeddedManifestationTypeMANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_FIRSTItem) ? get_class($embeddedManifestationTypeMANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_FIRSTItem) : gettype($embeddedManifestationTypeMANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_FIRSTItem)), __LINE__);
            }
        }
        $this->MANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_FIRST = $this->{'MANIFESTATION_OFFICIAL-JOURNAL_PART_PAGE_FIRST'} = $mANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_FIRST;
        return $this;
    }
    /**
     */
    public function addToMANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_FIRST(\StructType\Literal $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Literal) {
            throw new \InvalidArgumentException(sprintf('The MANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_FIRST property can only contain items of \StructType\Literal, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->MANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_FIRST[] = $item;
        return $this;
    }
    /**
     * Get mANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_LAST value
     * @return mANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_LAST
     */
    public function getMANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_LAST()
    {
        return $this->{'MANIFESTATION_OFFICIAL-JOURNAL_PART_PAGE_LAST'};
    }
    /**
     * Set mANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_LAST value
     * @param mANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_LAST $mANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_LAST
     * @return \StructType\EmbeddedManifestationType
     */
    public function setMANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_LAST(array $mANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_LAST = array())
    {
        foreach ($mANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_LAST as $embeddedManifestationTypeMANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_LASTItem) {
            // validation for constraint: itemType
            if (!$embeddedManifestationTypeMANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_LASTItem instanceof \StructType\Literal) {
                throw new \InvalidArgumentException(sprintf('The MANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_LAST property can only contain items of \StructType\Literal, "%s" given', is_object($embeddedManifestationTypeMANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_LASTItem) ? get_class($embeddedManifestationTypeMANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_LASTItem) : gettype($embeddedManifestationTypeMANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_LASTItem)), __LINE__);
            }
        }
        $this->MANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_LAST = $this->{'MANIFESTATION_OFFICIAL-JOURNAL_PART_PAGE_LAST'} = $mANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_LAST;
        return $this;
    }
    /**
     */
    public function addToMANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_LAST(\StructType\Literal $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Literal) {
            throw new \InvalidArgumentException(sprintf('The MANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_LAST property can only contain items of \StructType\Literal, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->MANIFESTATION_OFFICIAL_JOURNAL_PART_PAGE_LAST[] = $item;
        return $this;
    }
    /**
     * Get MANIFESTATION_PART_OF_MANIFESTATION value
     * @return \StructType\Concept[]|null
     */
    public function getMANIFESTATION_PART_OF_MANIFESTATION()
    {
        return $this->MANIFESTATION_PART_OF_MANIFESTATION;
    }
    /**
     * Set MANIFESTATION_PART_OF_MANIFESTATION value
     * @throws \InvalidArgumentException
     * @param \StructType\Concept[] $mANIFESTATION_PART_OF_MANIFESTATION
     * @return \StructType\EmbeddedManifestationType
     */
    public function setMANIFESTATION_PART_OF_MANIFESTATION(array $mANIFESTATION_PART_OF_MANIFESTATION = array())
    {
        foreach ($mANIFESTATION_PART_OF_MANIFESTATION as $embeddedManifestationTypeMANIFESTATION_PART_OF_MANIFESTATIONItem) {
            // validation for constraint: itemType
            if (!$embeddedManifestationTypeMANIFESTATION_PART_OF_MANIFESTATIONItem instanceof \StructType\Concept) {
                throw new \InvalidArgumentException(sprintf('The MANIFESTATION_PART_OF_MANIFESTATION property can only contain items of \StructType\Concept, "%s" given', is_object($embeddedManifestationTypeMANIFESTATION_PART_OF_MANIFESTATIONItem) ? get_class($embeddedManifestationTypeMANIFESTATION_PART_OF_MANIFESTATIONItem) : gettype($embeddedManifestationTypeMANIFESTATION_PART_OF_MANIFESTATIONItem)), __LINE__);
            }
        }
        $this->MANIFESTATION_PART_OF_MANIFESTATION = $mANIFESTATION_PART_OF_MANIFESTATION;
        return $this;
    }
    /**
     * Add item to MANIFESTATION_PART_OF_MANIFESTATION value
     * @throws \InvalidArgumentException
     * @param \StructType\Concept $item
     * @return \StructType\EmbeddedManifestationType
     */
    public function addToMANIFESTATION_PART_OF_MANIFESTATION(\StructType\Concept $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Concept) {
            throw new \InvalidArgumentException(sprintf('The MANIFESTATION_PART_OF_MANIFESTATION property can only contain items of \StructType\Concept, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->MANIFESTATION_PART_OF_MANIFESTATION[] = $item;
        return $this;
    }
    /**
     * Get mANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_FIRST value
     * @return mANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_FIRST
     */
    public function getMANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_FIRST()
    {
        return $this->{'MANIFESTATION_SPECIAL-OFFICIAL-JOURNAL_PART_PAGE_FIRST'};
    }
    /**
     * Set mANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_FIRST value
     * @param mANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_FIRST $mANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_FIRST
     * @return \StructType\EmbeddedManifestationType
     */
    public function setMANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_FIRST(array $mANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_FIRST = array())
    {
        foreach ($mANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_FIRST as $embeddedManifestationTypeMANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_FIRSTItem) {
            // validation for constraint: itemType
            if (!$embeddedManifestationTypeMANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_FIRSTItem instanceof \StructType\Literal) {
                throw new \InvalidArgumentException(sprintf('The MANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_FIRST property can only contain items of \StructType\Literal, "%s" given', is_object($embeddedManifestationTypeMANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_FIRSTItem) ? get_class($embeddedManifestationTypeMANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_FIRSTItem) : gettype($embeddedManifestationTypeMANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_FIRSTItem)), __LINE__);
            }
        }
        $this->MANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_FIRST = $this->{'MANIFESTATION_SPECIAL-OFFICIAL-JOURNAL_PART_PAGE_FIRST'} = $mANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_FIRST;
        return $this;
    }
    /**
     */
    public function addToMANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_FIRST(\StructType\Literal $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Literal) {
            throw new \InvalidArgumentException(sprintf('The MANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_FIRST property can only contain items of \StructType\Literal, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->MANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_FIRST[] = $item;
        return $this;
    }
    /**
     * Get mANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_LAST value
     * @return mANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_LAST
     */
    public function getMANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_LAST()
    {
        return $this->{'MANIFESTATION_SPECIAL-OFFICIAL-JOURNAL_PART_PAGE_LAST'};
    }
    /**
     * Set mANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_LAST value
     * @param mANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_LAST $mANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_LAST
     * @return \StructType\EmbeddedManifestationType
     */
    public function setMANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_LAST(array $mANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_LAST = array())
    {
        foreach ($mANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_LAST as $embeddedManifestationTypeMANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_LASTItem) {
            // validation for constraint: itemType
            if (!$embeddedManifestationTypeMANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_LASTItem instanceof \StructType\Literal) {
                throw new \InvalidArgumentException(sprintf('The MANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_LAST property can only contain items of \StructType\Literal, "%s" given', is_object($embeddedManifestationTypeMANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_LASTItem) ? get_class($embeddedManifestationTypeMANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_LASTItem) : gettype($embeddedManifestationTypeMANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_LASTItem)), __LINE__);
            }
        }
        $this->MANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_LAST = $this->{'MANIFESTATION_SPECIAL-OFFICIAL-JOURNAL_PART_PAGE_LAST'} = $mANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_LAST;
        return $this;
    }
    /**
     */
    public function addToMANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_LAST(\StructType\Literal $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Literal) {
            throw new \InvalidArgumentException(sprintf('The MANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_LAST property can only contain items of \StructType\Literal, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->MANIFESTATION_SPECIAL_OFFICIAL_JOURNAL_PART_PAGE_LAST[] = $item;
        return $this;
    }
    /**
     * Get SAMEAS value
     * @return \StructType\SAMEAS[]|null
     */
    public function getSAMEAS()
    {
        return $this->SAMEAS;
    }
    /**
     * Set SAMEAS value
     * @throws \InvalidArgumentException
     * @param \StructType\SAMEAS[] $sAMEAS
     * @return \StructType\EmbeddedManifestationType
     */
    public function setSAMEAS(array $sAMEAS = array())
    {
        foreach ($sAMEAS as $embeddedManifestationTypeSAMEASItem) {
            // validation for constraint: itemType
            if (!$embeddedManifestationTypeSAMEASItem instanceof \StructType\SAMEAS) {
                throw new \InvalidArgumentException(sprintf('The SAMEAS property can only contain items of \StructType\SAMEAS, "%s" given', is_object($embeddedManifestationTypeSAMEASItem) ? get_class($embeddedManifestationTypeSAMEASItem) : gettype($embeddedManifestationTypeSAMEASItem)), __LINE__);
            }
        }
        $this->SAMEAS = $sAMEAS;
        return $this;
    }
    /**
     * Add item to SAMEAS value
     * @throws \InvalidArgumentException
     * @param \StructType\SAMEAS $item
     * @return \StructType\EmbeddedManifestationType
     */
    public function addToSAMEAS(\StructType\SAMEAS $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SAMEAS) {
            throw new \InvalidArgumentException(sprintf('The SAMEAS property can only contain items of \StructType\SAMEAS, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->SAMEAS[] = $item;
        return $this;
    }
    /**
     * Get URI value
     * @return \StructType\URI|null
     */
    public function getURI()
    {
        return $this->URI;
    }
    /**
     * Set URI value
     * @param \StructType\URI $uRI
     * @return \StructType\EmbeddedManifestationType
     */
    public function setURI(\StructType\URI $uRI = null)
    {
        $this->URI = $uRI;
        return $this;
    }
    /**
     * Get manifestation_type value
     * @return manifestation_type
     */
    public function getManifestation_type()
    {
        return $this->{'manifestation-type'};
    }
    /**
     * Set manifestation_type value
     * @param manifestation_type $manifestation_type
     * @return \StructType\EmbeddedManifestationType
     */
    public function setManifestation_type(UNKNOWN $manifestation_type = null)
    {
        $this->manifestation_type = $this->{'manifestation-type'} = $manifestation_type;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\EmbeddedManifestationType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
