<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for expressionType StructType
 * @subpackage Structs
 */
class ExpressionType extends AbstractStructBase
{
    /**
     * The EXPRESSION_CASE_LAW_IDENTIFIER_CASE
     */
    public $EXPRESSION_CASE_LAW_IDENTIFIER_CASE;
    /**
     * The EXPRESSION_CASE_LAW_PARTIES
     */
    public $EXPRESSION_CASE_LAW_PARTIES;
    /**
     * The EXPRESSION_SUBTITLE
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - ref: EXPRESSION_SUBTITLE
     * @var \StructType\Literal[]
     */
    public $EXPRESSION_SUBTITLE;
    /**
     * The EXPRESSION_TITLE
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - ref: EXPRESSION_TITLE
     * @var \StructType\Literal[]
     */
    public $EXPRESSION_TITLE;
    /**
     * The EXPRESSION_TITLE_ALTERNATIVE
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - ref: EXPRESSION_TITLE_ALTERNATIVE
     * @var \StructType\Literal[]
     */
    public $EXPRESSION_TITLE_ALTERNATIVE;
    /**
     * The EXPRESSION_USES_LANGUAGE
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - ref: EXPRESSION_USES_LANGUAGE
     * @var \StructType\Concept[]
     */
    public $EXPRESSION_USES_LANGUAGE;
    /**
     * Constructor method for expressionType
     * @uses ExpressionType::setEXPRESSION_CASE_LAW_IDENTIFIER_CASE()
     * @uses ExpressionType::setEXPRESSION_CASE_LAW_PARTIES()
     * @uses ExpressionType::setEXPRESSION_SUBTITLE()
     * @uses ExpressionType::setEXPRESSION_TITLE()
     * @uses ExpressionType::setEXPRESSION_TITLE_ALTERNATIVE()
     * @uses ExpressionType::setEXPRESSION_USES_LANGUAGE()
     * @param \StructType\Literal[] $eXPRESSION_CASE_LAW_IDENTIFIER_CASE
     * @param \StructType\Literal[] $eXPRESSION_CASE_LAW_PARTIES
     * @param \StructType\Literal[] $eXPRESSION_SUBTITLE
     * @param \StructType\Literal[] $eXPRESSION_TITLE
     * @param \StructType\Literal[] $eXPRESSION_TITLE_ALTERNATIVE
     * @param \StructType\Concept[] $eXPRESSION_USES_LANGUAGE
     */
    public function __construct(array $eXPRESSION_CASE_LAW_IDENTIFIER_CASE = array(), array $eXPRESSION_CASE_LAW_PARTIES = array(), array $eXPRESSION_SUBTITLE = array(), array $eXPRESSION_TITLE = array(), array $eXPRESSION_TITLE_ALTERNATIVE = array(), array $eXPRESSION_USES_LANGUAGE = array())
    {
        $this
            ->setEXPRESSION_CASE_LAW_IDENTIFIER_CASE($eXPRESSION_CASE_LAW_IDENTIFIER_CASE)
            ->setEXPRESSION_CASE_LAW_PARTIES($eXPRESSION_CASE_LAW_PARTIES)
            ->setEXPRESSION_SUBTITLE($eXPRESSION_SUBTITLE)
            ->setEXPRESSION_TITLE($eXPRESSION_TITLE)
            ->setEXPRESSION_TITLE_ALTERNATIVE($eXPRESSION_TITLE_ALTERNATIVE)
            ->setEXPRESSION_USES_LANGUAGE($eXPRESSION_USES_LANGUAGE);
    }
    /**
     * Get eXPRESSION_CASE_LAW_IDENTIFIER_CASE value
     * @return eXPRESSION_CASE_LAW_IDENTIFIER_CASE
     */
    public function getEXPRESSION_CASE_LAW_IDENTIFIER_CASE()
    {
        return $this->{'EXPRESSION_CASE-LAW_IDENTIFIER_CASE'};
    }
    /**
     * Set eXPRESSION_CASE_LAW_IDENTIFIER_CASE value
     * @param eXPRESSION_CASE_LAW_IDENTIFIER_CASE $eXPRESSION_CASE_LAW_IDENTIFIER_CASE
     * @return \StructType\ExpressionType
     */
    public function setEXPRESSION_CASE_LAW_IDENTIFIER_CASE(array $eXPRESSION_CASE_LAW_IDENTIFIER_CASE = array())
    {
        foreach ($eXPRESSION_CASE_LAW_IDENTIFIER_CASE as $expressionTypeEXPRESSION_CASE_LAW_IDENTIFIER_CASEItem) {
            // validation for constraint: itemType
            if (!$expressionTypeEXPRESSION_CASE_LAW_IDENTIFIER_CASEItem instanceof \StructType\Literal) {
                throw new \InvalidArgumentException(sprintf('The EXPRESSION_CASE_LAW_IDENTIFIER_CASE property can only contain items of \StructType\Literal, "%s" given', is_object($expressionTypeEXPRESSION_CASE_LAW_IDENTIFIER_CASEItem) ? get_class($expressionTypeEXPRESSION_CASE_LAW_IDENTIFIER_CASEItem) : gettype($expressionTypeEXPRESSION_CASE_LAW_IDENTIFIER_CASEItem)), __LINE__);
            }
        }
        $this->EXPRESSION_CASE_LAW_IDENTIFIER_CASE = $this->{'EXPRESSION_CASE-LAW_IDENTIFIER_CASE'} = $eXPRESSION_CASE_LAW_IDENTIFIER_CASE;
        return $this;
    }
    /**
     */
    public function addToEXPRESSION_CASE_LAW_IDENTIFIER_CASE(\StructType\Literal $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Literal) {
            throw new \InvalidArgumentException(sprintf('The EXPRESSION_CASE_LAW_IDENTIFIER_CASE property can only contain items of \StructType\Literal, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->EXPRESSION_CASE_LAW_IDENTIFIER_CASE[] = $item;
        return $this;
    }
    /**
     * Get eXPRESSION_CASE_LAW_PARTIES value
     * @return eXPRESSION_CASE_LAW_PARTIES
     */
    public function getEXPRESSION_CASE_LAW_PARTIES()
    {
        return $this->{'EXPRESSION_CASE-LAW_PARTIES'};
    }
    /**
     * Set eXPRESSION_CASE_LAW_PARTIES value
     * @param eXPRESSION_CASE_LAW_PARTIES $eXPRESSION_CASE_LAW_PARTIES
     * @return \StructType\ExpressionType
     */
    public function setEXPRESSION_CASE_LAW_PARTIES(array $eXPRESSION_CASE_LAW_PARTIES = array())
    {
        foreach ($eXPRESSION_CASE_LAW_PARTIES as $expressionTypeEXPRESSION_CASE_LAW_PARTIESItem) {
            // validation for constraint: itemType
            if (!$expressionTypeEXPRESSION_CASE_LAW_PARTIESItem instanceof \StructType\Literal) {
                throw new \InvalidArgumentException(sprintf('The EXPRESSION_CASE_LAW_PARTIES property can only contain items of \StructType\Literal, "%s" given', is_object($expressionTypeEXPRESSION_CASE_LAW_PARTIESItem) ? get_class($expressionTypeEXPRESSION_CASE_LAW_PARTIESItem) : gettype($expressionTypeEXPRESSION_CASE_LAW_PARTIESItem)), __LINE__);
            }
        }
        $this->EXPRESSION_CASE_LAW_PARTIES = $this->{'EXPRESSION_CASE-LAW_PARTIES'} = $eXPRESSION_CASE_LAW_PARTIES;
        return $this;
    }
    /**
     */
    public function addToEXPRESSION_CASE_LAW_PARTIES(\StructType\Literal $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Literal) {
            throw new \InvalidArgumentException(sprintf('The EXPRESSION_CASE_LAW_PARTIES property can only contain items of \StructType\Literal, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->EXPRESSION_CASE_LAW_PARTIES[] = $item;
        return $this;
    }
    /**
     * Get EXPRESSION_SUBTITLE value
     * @return \StructType\Literal[]|null
     */
    public function getEXPRESSION_SUBTITLE()
    {
        return $this->EXPRESSION_SUBTITLE;
    }
    /**
     * Set EXPRESSION_SUBTITLE value
     * @throws \InvalidArgumentException
     * @param \StructType\Literal[] $eXPRESSION_SUBTITLE
     * @return \StructType\ExpressionType
     */
    public function setEXPRESSION_SUBTITLE(array $eXPRESSION_SUBTITLE = array())
    {
        foreach ($eXPRESSION_SUBTITLE as $expressionTypeEXPRESSION_SUBTITLEItem) {
            // validation for constraint: itemType
            if (!$expressionTypeEXPRESSION_SUBTITLEItem instanceof \StructType\Literal) {
                throw new \InvalidArgumentException(sprintf('The EXPRESSION_SUBTITLE property can only contain items of \StructType\Literal, "%s" given', is_object($expressionTypeEXPRESSION_SUBTITLEItem) ? get_class($expressionTypeEXPRESSION_SUBTITLEItem) : gettype($expressionTypeEXPRESSION_SUBTITLEItem)), __LINE__);
            }
        }
        $this->EXPRESSION_SUBTITLE = $eXPRESSION_SUBTITLE;
        return $this;
    }
    /**
     * Add item to EXPRESSION_SUBTITLE value
     * @throws \InvalidArgumentException
     * @param \StructType\Literal $item
     * @return \StructType\ExpressionType
     */
    public function addToEXPRESSION_SUBTITLE(\StructType\Literal $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Literal) {
            throw new \InvalidArgumentException(sprintf('The EXPRESSION_SUBTITLE property can only contain items of \StructType\Literal, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->EXPRESSION_SUBTITLE[] = $item;
        return $this;
    }
    /**
     * Get EXPRESSION_TITLE value
     * @return \StructType\Literal[]|null
     */
    public function getEXPRESSION_TITLE()
    {
        return $this->EXPRESSION_TITLE;
    }
    /**
     * Set EXPRESSION_TITLE value
     * @throws \InvalidArgumentException
     * @param \StructType\Literal[] $eXPRESSION_TITLE
     * @return \StructType\ExpressionType
     */
    public function setEXPRESSION_TITLE(array $eXPRESSION_TITLE = array())
    {
        foreach ($eXPRESSION_TITLE as $expressionTypeEXPRESSION_TITLEItem) {
            // validation for constraint: itemType
            if (!$expressionTypeEXPRESSION_TITLEItem instanceof \StructType\Literal) {
                throw new \InvalidArgumentException(sprintf('The EXPRESSION_TITLE property can only contain items of \StructType\Literal, "%s" given', is_object($expressionTypeEXPRESSION_TITLEItem) ? get_class($expressionTypeEXPRESSION_TITLEItem) : gettype($expressionTypeEXPRESSION_TITLEItem)), __LINE__);
            }
        }
        $this->EXPRESSION_TITLE = $eXPRESSION_TITLE;
        return $this;
    }
    /**
     * Add item to EXPRESSION_TITLE value
     * @throws \InvalidArgumentException
     * @param \StructType\Literal $item
     * @return \StructType\ExpressionType
     */
    public function addToEXPRESSION_TITLE(\StructType\Literal $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Literal) {
            throw new \InvalidArgumentException(sprintf('The EXPRESSION_TITLE property can only contain items of \StructType\Literal, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->EXPRESSION_TITLE[] = $item;
        return $this;
    }
    /**
     * Get EXPRESSION_TITLE_ALTERNATIVE value
     * @return \StructType\Literal[]|null
     */
    public function getEXPRESSION_TITLE_ALTERNATIVE()
    {
        return $this->EXPRESSION_TITLE_ALTERNATIVE;
    }
    /**
     * Set EXPRESSION_TITLE_ALTERNATIVE value
     * @throws \InvalidArgumentException
     * @param \StructType\Literal[] $eXPRESSION_TITLE_ALTERNATIVE
     * @return \StructType\ExpressionType
     */
    public function setEXPRESSION_TITLE_ALTERNATIVE(array $eXPRESSION_TITLE_ALTERNATIVE = array())
    {
        foreach ($eXPRESSION_TITLE_ALTERNATIVE as $expressionTypeEXPRESSION_TITLE_ALTERNATIVEItem) {
            // validation for constraint: itemType
            if (!$expressionTypeEXPRESSION_TITLE_ALTERNATIVEItem instanceof \StructType\Literal) {
                throw new \InvalidArgumentException(sprintf('The EXPRESSION_TITLE_ALTERNATIVE property can only contain items of \StructType\Literal, "%s" given', is_object($expressionTypeEXPRESSION_TITLE_ALTERNATIVEItem) ? get_class($expressionTypeEXPRESSION_TITLE_ALTERNATIVEItem) : gettype($expressionTypeEXPRESSION_TITLE_ALTERNATIVEItem)), __LINE__);
            }
        }
        $this->EXPRESSION_TITLE_ALTERNATIVE = $eXPRESSION_TITLE_ALTERNATIVE;
        return $this;
    }
    /**
     * Add item to EXPRESSION_TITLE_ALTERNATIVE value
     * @throws \InvalidArgumentException
     * @param \StructType\Literal $item
     * @return \StructType\ExpressionType
     */
    public function addToEXPRESSION_TITLE_ALTERNATIVE(\StructType\Literal $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Literal) {
            throw new \InvalidArgumentException(sprintf('The EXPRESSION_TITLE_ALTERNATIVE property can only contain items of \StructType\Literal, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->EXPRESSION_TITLE_ALTERNATIVE[] = $item;
        return $this;
    }
    /**
     * Get EXPRESSION_USES_LANGUAGE value
     * @return \StructType\Concept[]|null
     */
    public function getEXPRESSION_USES_LANGUAGE()
    {
        return $this->EXPRESSION_USES_LANGUAGE;
    }
    /**
     * Set EXPRESSION_USES_LANGUAGE value
     * @throws \InvalidArgumentException
     * @param \StructType\Concept[] $eXPRESSION_USES_LANGUAGE
     * @return \StructType\ExpressionType
     */
    public function setEXPRESSION_USES_LANGUAGE(array $eXPRESSION_USES_LANGUAGE = array())
    {
        foreach ($eXPRESSION_USES_LANGUAGE as $expressionTypeEXPRESSION_USES_LANGUAGEItem) {
            // validation for constraint: itemType
            if (!$expressionTypeEXPRESSION_USES_LANGUAGEItem instanceof \StructType\Concept) {
                throw new \InvalidArgumentException(sprintf('The EXPRESSION_USES_LANGUAGE property can only contain items of \StructType\Concept, "%s" given', is_object($expressionTypeEXPRESSION_USES_LANGUAGEItem) ? get_class($expressionTypeEXPRESSION_USES_LANGUAGEItem) : gettype($expressionTypeEXPRESSION_USES_LANGUAGEItem)), __LINE__);
            }
        }
        $this->EXPRESSION_USES_LANGUAGE = $eXPRESSION_USES_LANGUAGE;
        return $this;
    }
    /**
     * Add item to EXPRESSION_USES_LANGUAGE value
     * @throws \InvalidArgumentException
     * @param \StructType\Concept $item
     * @return \StructType\ExpressionType
     */
    public function addToEXPRESSION_USES_LANGUAGE(\StructType\Concept $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Concept) {
            throw new \InvalidArgumentException(sprintf('The EXPRESSION_USES_LANGUAGE property can only contain items of \StructType\Concept, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->EXPRESSION_USES_LANGUAGE[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ExpressionType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
